#version 330 core
layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

in VS_OUT {
	vec3 pos;
	vec3 norm;
	vec2 texCoords;
} gs_in[];

// output for each vertex emiting
out vec3 Normal;  
out vec3 FragPos;  
out vec2 TexCoords;

void main(){
	// calculate flat normal
	vec3 oa=gs_in[1].pos-gs_in[0].pos;
	vec3 ob=gs_in[2].pos-gs_in[0].pos;
	vec3 norm=normalize(cross(oa, ob));
	
	for(int i=0; i<3; i++){
		// preparing vertex data for emiting
		gl_Position=gl_in[i].gl_Position;
		
		Normal = norm;
		FragPos=gs_in[i].pos;
		TexCoords=gs_in[i].texCoords;
		
		EmitVertex();
	}
	EndPrimitive();
}