

// Define input layout
layout(location = 0) in vec3 InPos;
layout(location = 1) in vec3 InNormal;
layout(location = 2) in vec2 InUV;

// Define uniforms
uniform mat4 World;
uniform mat4 View;
uniform mat4 Proj;
uniform mat4 PVW;
uniform mat4 ShadowPVW;

// Define output
#ifndef INTERPOLATE
flat out vec3 WPos;
flat out vec3 ShadowPos;
#else
out vec3 WPos;
out vec3 ShadowPos;
#endif


void main()
{
	WPos = (World*vec4(InPos,1.0f)).xyz;

	float rand_offset = length((cos(WPos)*sin(0.7*WPos)));
	rand_offset *= 0.075f;
	WPos.z += rand_offset;

	gl_Position = Proj*View*vec4(WPos,1.0f);//PVW*vec4(InPos,1.0f);

	// Normals are not used, they are sampled directly from the texture
	// UVs are not used, texture is sampled using the world pos

	vec4 sh = ShadowPVW*vec4(InPos,1.0f);
	sh.xyz /= sh.w;
	sh.xyz = sh.xyz*0.5 + 0.5;
	ShadowPos = sh.xyz;
}